﻿using System;

namespace ELTE.BoardGame.ViewModel
{
    /// <summary>
    /// Játékmező nézetmodell típusa.
    /// </summary>
    public class BoardItemViewModel : ViewModelBase
    {
        private String player;

        /// <summary>
        /// Játékmező nézetmodell példányosítása.
        /// </summary>
        /// <param name="itemAction">Ackió.</param>
        public BoardItemViewModel(Action<Object> itemAction)
        {
            this.BoardItemCommand = new DelegateCommand(itemAction);
        }

        /// <summary>
        /// Oszlop lekérdezése, vagy beállítása.
        /// </summary>
        public Int32 Column { get; set; }

        /// <summary>
        /// Sor lekérdezése, vagy beállítása.
        /// </summary>
        public Int32 Row { get; set; }

        /// <summary>
        /// Sorszám lekérdezése, vagy beállítása.
        /// </summary>
        public Int32 Number { get; set; }
        
        /// <summary>
        /// Játékos lekérdezése, vagy beállítása.
        /// </summary>
        public String Player 
        { 
            get { return this.player; }
            set
            {
                if (this.player != value)
                {
                    this.player = value;
                    OnPropertyChanged(); // változásjelzés
                }
            }
        }

        /// <summary>
        /// Mezőparancs lekérdezése, vagy beállítása.
        /// </summary>
        public DelegateCommand BoardItemCommand { get; private set; }
    }
}
